gp-grid-logo
API Reference

Grid Props

Reference for every prop accepted by the Vue 3 Grid component, including data sources, columns, sorting, filtering, selection, and editing controls today.

All properties accepted by the Vue Grid component. Props use kebab-case in templates.

Required Props

columns

Type: ColumnDefinition[]

Array of column definitions.

<template>
  <Grid :columns="columns" ... />
</template>

row-height

Type: number

Height of each row in pixels.

<template>
  <Grid :row-height="36" ... />
</template>

Data Props

row-data

Type: TData[]

Array of row data objects.

<script setup>
const data = ref([
  { id: 1, name: "Giovanni" },
  { id: 2, name: "Luca" },
]);
</script>

<template>
  <Grid :row-data="data" ... />
</template>

data-source

Type: DataSource<TData>

Data source for advanced data handling.

<script setup>
const dataSource = createClientDataSource(data);
</script>

<template>
  <Grid :data-source="dataSource" ... />
</template>

Optional Props

header-height

Type: number Default: Same as row-height

<template>
  <Grid :header-height="48" ... />
</template>

overscan

Type: number Default: 3

Number of rows to render outside viewport.

sorting-enabled

Type: boolean Default: true

Enable/disable sorting globally.

dark-mode

Type: boolean Default: false

Enable dark mode styling.

wheel-dampening

Type: number Default: 0.1

Dampening factor for wheel scrolling (0-1).

Enabling this prop activates smooth scrolling for grids that exceed millions of rows by using virtual dampening, which keeps wheel-based navigation fluid on very large datasets.

max-fling-velocity

Type: number Default: 20 × rowHeight

Maximum accumulated touch-fling velocity in logical px/ms when scroll virtualization is active. Pair higher values with overscan 10–12 for smoother fast scrolling on touch devices.

<template>
  <Grid
    :columns="columns"
    :row-data="data"
    :row-height="36"
    :max-fling-velocity="2000"
    :overscan="12"
  />
</template>

Drag & Reorder Props

row-drag-entire-row

Type: boolean Default: false

When enabled, clicking and dragging any cell initiates a row drag.

<template>
  <Grid :row-drag-entire-row="true" @row-drag-end="handleRowDragEnd" ... />
</template>

@row-drag-end

Type: (sourceIndex: number, targetIndex: number) => void

Emitted when a row is dropped after dragging. The consumer handles data reordering.

@column-moved

Type: (fromIndex: number, toIndex: number) => void

Emitted when a column header is dragged to a new position.

@column-resized

Type: (colIndex: number, newWidth: number) => void

Emitted when a column is resized by dragging the header edge.

SSR Props

initial-width

Type: number

Initial viewport width in pixels for server-side rendering. On the client, a ResizeObserver takes over automatically.

initial-height

Type: number

Initial viewport height in pixels for server-side rendering.

Identity & Edit Props

get-row-id

Type: (row: TData) => RowId

Function to extract a unique ID from each row. Required when onCellValueChanged is provided.

<template>
  <Grid
    :columns="columns"
    :row-data="data"
    :row-height="36"
    :get-row-id="(row) => row.id"
    @cell-value-changed="handleCellValueChanged"
  />
</template>

@cell-value-changed

Type: (event: CellValueChangedEvent<TData>) => void

Emitted after a cell value is committed via inline editing or fill-handle drag.

Styling Props

highlighting

Type: HighlightingOptions<TData>

Dynamic row, column, and cell class computation. See the Styling guide for detailed usage.

<template>
  <Grid
    :columns="columns"
    :row-data="data"
    :row-height="36"
    :highlighting="{
      computeRowClasses: (ctx) =>
        ctx.rowIndex != null && ctx.rowIndex % 2 === 1 ? ['zebra-row'] : [],
    }"
  />
</template>

Localization Props

labels

Type: GridLabelOverrides Default: English defaults

Override any user-visible grid string — the filter popup, its buttons and placeholders, the empty state and the error prefix. Unspecified labels keep their English defaults.

<script setup lang="ts">
import { GpGrid, type GridLabelOverrides } from "@gp-grid/vue";

const labels: GridLabelOverrides = {
  filterTitle: "Filtra: {column}", // {column} is the column header name
  and: "E",
  apply: "Applica",
  emptyState: "Nessun dato",
};
</script>

<template>
  <GpGrid :columns="columns" :row-data="rows" :row-height="36" :labels="labels" />
</template>

The most common keys:

KeyTokenMeaning
filterTitle{column}Filter popup title
and / or—Combination toggle
apply / clear / addCondition / removeCondition—Condition buttons
addGroup / removeGroup—Condition-group buttons
valuePlaceholder / searchPlaceholder / betweenSeparator—Inputs
valuesMode / conditionMode—Popup mode toggle
selectAll / deselectAll / blanks—Values-mode controls
tooManyValues{count}Too-many-values message
emptyState—Empty grid message
errorPrefix{message}Error message prefix
operators.*—Filter dropdown labels (contains, startsWith, between, …)

operators is also a partial override, so one operator can be changed without copying the English defaults: operators: { contains: "Contiene" }.

Loading Props

loading-component

Type: Component<{ isLoading: boolean }>

Custom component rendered during data loading instead of the default spinner.

Renderer Props

cell-renderer

Type: VueCellRenderer

Global cell renderer.

cell-renderers

Type: Record<string, VueCellRenderer>

Named cell renderer registry.

edit-renderer / edit-renderers

Custom edit renderers.

header-renderer / header-renderers

Custom header renderers.

Template Ref

You can access the underlying GridCore instance via a template ref:

<script setup>
import { ref } from "vue";

const gridRef = ref(null);

function sortByName() {
  gridRef.value?.core?.setSort("name", "asc");
}
</script>

<template>
  <GpGrid ref="gridRef" :columns="columns" :row-data="data" :row-height="36" />
</template>

Example

<template>
  <Grid
    :columns="columns"
    :row-data="data"
    :row-height="36"
    :header-height="48"
    :overscan="5"
    :sorting-enabled="true"
    :dark-mode="isDark"
    :cell-renderers="{ status: StatusRenderer }"
  />
</template>

On this page

gp-grid-logo
API Reference

Grid Props

Reference for every input and output exposed by the Angular Grid component, covering data sources, columns, sorting, filtering, and selection inputs today.

The GpGridComponent is a standalone Angular component with OnPush change detection. Binder syntax is standard Angular: [inputName] for inputs and (outputName) for outputs.

Required Inputs

[columns]

Type: AngularColumnDefinition[]

Array of column definitions. See Column Definition for details.

@Component({
  standalone: true,
  imports: [GpGridComponent],
  template: `<gp-grid [columns]="columns" [rowData]="data" [rowHeight]="36" />`,
})
export class MyGridComponent {
  columns: AngularColumnDefinition[] = [
    { field: "id", cellDataType: "number", width: 80 },
    { field: "name", cellDataType: "text", width: 200 },
  ];
}

[rowHeight]

Type: number

Height of each row in pixels.

<gp-grid [columns]="columns" [rowData]="data" [rowHeight]="36" />

Data Inputs

[rowData]

Type: TData[]

Array of row data objects. The simplest way to provide data.

<gp-grid [columns]="columns" [rowData]="data" [rowHeight]="36" />

[dataSource]

Type: DataSource<TData>

Data source for advanced data handling. Use this for server-side data or when you need mutation capabilities. See Data Sources.

<gp-grid [columns]="columns" [dataSource]="dataSource" [rowHeight]="36" />

Optional Inputs

[headerHeight]

Type: number Default: Same as [rowHeight]

Height of the header row in pixels.

<gp-grid [columns]="columns" [rowData]="data" [rowHeight]="36" [headerHeight]="48" />

[overscan]

Type: number Default: 3

Number of rows to render outside the visible viewport.

<gp-grid [columns]="columns" [rowData]="data" [rowHeight]="36" [overscan]="5" />

[sortingEnabled]

Type: boolean Default: true

Enable or disable sorting globally.

<gp-grid [columns]="columns" [rowData]="data" [rowHeight]="36" [sortingEnabled]="false" />

[darkMode]

Type: boolean Default: false

Enable dark mode styling.

<gp-grid [columns]="columns" [rowData]="data" [rowHeight]="36" [darkMode]="true" />

[wheelDampening]

Type: number Default: 0.1

Dampening factor for wheel scrolling (0–1).

Enabling this input activates smooth scrolling for grids that exceed millions of rows by using virtual dampening, which keeps wheel-based navigation fluid on very large datasets.

<gp-grid [columns]="columns" [rowData]="data" [rowHeight]="36" [wheelDampening]="0.2" />

[maxFlingVelocity]

Type: number Default: 20 × rowHeight

Maximum accumulated touch-fling velocity in logical px/ms when scroll virtualization is active. Pair higher values with overscan 10–12 for smoother fast scrolling on touch devices.

<gp-grid
  [columns]="columns"
  [rowData]="data"
  [rowHeight]="36"
  [maxFlingVelocity]="2000"
  [overscan]="12"
/>

Drag & Reorder Inputs / Outputs

[rowDragEntireRow]

Type: boolean Default: false

When enabled, clicking and dragging any cell in a row initiates a row drag instead of cell selection.

(onRowDragEnd)

Type: { source: number; target: number }

Emitted when a row is dropped after dragging.

@Component({
  template: `
    <gp-grid
      [columns]="columns"
      [dataSource]="dataSource"
      [rowHeight]="36"
      [rowDragEntireRow]="true"
      (onRowDragEnd)="handleRowDragEnd($event)"
    />
  `,
})
export class MyGridComponent {
  handleRowDragEnd({ source, target }: { source: number; target: number }) {
    this.dataSource.moveRow?.(source, target);
  }
}

(onColumnMoved)

Type: { fromIndex: number; toIndex: number }

Emitted when a column header is dragged to a new position.

@Component({
  template: `
    <gp-grid
      [columns]="columns"
      [rowData]="data"
      [rowHeight]="36"
      (onColumnMoved)="handleColumnMoved($event)"
    />
  `,
})
export class MyGridComponent {
  handleColumnMoved({ fromIndex, toIndex }: { fromIndex: number; toIndex: number }) {
    const next = [...this.columns];
    const [moved] = next.splice(fromIndex, 1);
    next.splice(toIndex, 0, moved);
    this.columns = next;
  }
}

(onColumnResized)

Type: { colIndex: number; newWidth: number }

Emitted when a column is resized by dragging the header edge.

Identity & Edit Inputs / Outputs

[getRowId]

Type: ((row: TData) => RowId) | null

Function to extract a unique ID from each row. Required when (onCellValueChanged) is used.

(onCellValueChanged)

Type: CellValueChangedEvent<TData>

Emitted after a cell value is committed via inline editing or fill-handle drag.

@Component({
  template: `
    <gp-grid
      [columns]="columns"
      [rowData]="data"
      [rowHeight]="36"
      [getRowId]="idGetter"
      (onCellValueChanged)="handleCellValueChanged($event)"
    />
  `,
})
export class MyGridComponent {
  idGetter = (row: MyRow) => row.id;
  handleCellValueChanged(event: CellValueChangedEvent<MyRow>) {
    console.log(`Row ${event.rowId} changed ${event.oldValue} → ${event.newValue}`);
  }
}

Styling Inputs

[highlighting]

Type: HighlightingOptions | null

Dynamic row, column, and cell class computation. See the Styling guide.

@Component({
  template: `
    <gp-grid
      [columns]="columns"
      [rowData]="data"
      [rowHeight]="36"
      [highlighting]="highlightingOptions"
    />
  `,
})
export class MyGridComponent {
  highlightingOptions: HighlightingOptions = {
    computeRowClasses: (ctx) =>
      ctx.rowIndex != null && ctx.rowIndex % 2 === 1 ? ["zebra-row"] : [],
    computeCellClasses: (ctx) =>
      ctx.isSelected ? ["bg-blue-50"] : [],
  };
}

Localization Inputs

[labels]

Type: GridLabelOverrides Default: English defaults

Override any user-visible grid string — the filter popup, its buttons and placeholders, the empty state and the error prefix. Unspecified labels keep their English defaults.

import { GpGridComponent } from "@gp-grid/angular";
import type { GridLabelOverrides } from "@gp-grid/angular";

@Component({
  template: `
    <gp-grid
      [columns]="columns"
      [rowData]="data"
      [rowHeight]="36"
      [labels]="labels"
    />
  `,
})
export class MyGridComponent {
  labels: GridLabelOverrides = {
    filterTitle: "Filtra: {column}", // {column} is the column header name
    and: "E",
    apply: "Applica",
    emptyState: "Nessun dato",
  };
}

The most common keys:

KeyTokenMeaning
filterTitle{column}Filter popup title
and / or—Combination toggle
apply / clear / addCondition / removeCondition—Condition buttons
addGroup / removeGroup—Condition-group buttons
valuePlaceholder / searchPlaceholder / betweenSeparator—Inputs
valuesMode / conditionMode—Popup mode toggle
selectAll / deselectAll / blanks—Values-mode controls
tooManyValues{count}Too-many-values message
emptyState—Empty grid message
errorPrefix{message}Error message prefix
operators.*—Filter dropdown labels (contains, startsWith, between, …)

operators is also a partial override, so one operator can be changed without copying the English defaults: operators: { contains: "Contiene" }.

Renderer Inputs

[cellRenderers]

Type: Record<string, CellRendererTemplate>

Registry of named cell renderers. Reference by key in column definitions.

[editRenderers]

Type: Record<string, EditRendererTemplate>

Registry of named edit renderers.

[headerRenderers]

Type: Record<string, HeaderRendererTemplate>

Registry of named header renderers.

[cellRenderer]

Type: CellRendererTemplate | null

Global cell renderer for all cells.

[editRenderer]

Type: EditRendererTemplate | null

Global edit renderer.

[headerRenderer]

Type: HeaderRendererTemplate | null

Global header renderer.

Template Ref

You can access the underlying component instance (and its core property) via a template ref:

@Component({
  template: `
    <gp-grid #grid [columns]="columns" [rowData]="data" [rowHeight]="36" />
    <button (click)="sortByName(grid)">Sort by name</button>
  `,
})
export class MyGridComponent {
  sortByName(grid: GpGridComponent) {
    grid.vm.coreRef?.setSort("name", "asc");
  }
}

On this page